﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.GridHelperClasses;
using Syncfusion.Windows.Forms;
using Syncfusion.Drawing;
using System.Collections;

namespace WindowsFormsApplication21
{

    public partial class Form1 : Form
    {
        private int recordcount;
        private DataTable table;
        private Random rand1,rand2;
        private StringCollection list1;
        private int i;
        public Form1()
        {

            InitializeComponent();
            rand1 = new Random();
            rand2 = new Random();
            list1 = new StringCollection();
            list1.Add("trial1");
            list1.Add("trial2");
            list1.Add("trial3");
            this.gridGroupingControl1.AllowProportionalColumnSizing = true;
            this.gridGroupingControl1.ShowGroupDropArea = true;
            this.gridGroupingControl1.DataSource = ReturnATable();
            this.gridGroupingControl1.TableDescriptor.Columns["Date"].Appearance.AnyCell.CellValueType = typeof(DateTime);
            this.gridGroupingControl1.TableDescriptor.Columns["Date"].Appearance.AnyCell.Format = "MMM-yyyy";
            this.gridGroupingControl1.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);
            gridGroupingControl1.TableDescriptor.SortedColumns.Changing += new Syncfusion.Collections.ListPropertyChangedEventHandler(SortedColumns_Changing);

        }

        void SortedColumns_Changing(object sender, Syncfusion.Collections.ListPropertyChangedEventArgs e)
        {
            SortColumnDescriptor sd = e.Item as SortColumnDescriptor;
            if (sd != null && e.Action == Syncfusion.Collections.ListPropertyChangedType.Add)
            {
                Type type = this.gridGroupingControl1.TableDescriptor.Columns[sd.Name].Appearance.AnyRecordFieldCell.CellValueType;
                if (sd.Name == "Date" && type == typeof(DateTime))
                    sd.Comparer = new DateComparer();

            }
        }

      
        void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            if (e.TableCellIdentity.TableCellType == GridTableCellType.GroupCaptionCell && e.TableCellIdentity.GroupedColumn != null)
            {
                GridCaptionRow captionRow = e.TableCellIdentity.DisplayElement as GridCaptionRow;
                string date="";
                DateTime dt;
                if (e.Style.Text != null && DateTime.TryParse(e.Style.Text.Substring(e.Style.Text.IndexOf(":") + 1, 8),out dt))
                {
                    date = dt.ToString("MMM-yyyy");
                }
                e.Style.CellValue = String.Format("{0}: {1} Items.", date, e.TableCellIdentity.DisplayElement.ParentGroup.GetChildCount());

            }
        }

       
           
        private DataTable ReturnATable()
        {
            table = new DataTable("People");

            //Adds two columns.
            table.Columns.Add(new DataColumn("FirstName"));
            table.Columns.Add(new DataColumn("LastName"));
            table.Columns.Add(new DataColumn("Date"));
            table.Columns.Add(new DataColumn("Age"));
            
            //Adds some rows.
            DataRow dr = table.NewRow();
            dr["FirstName"] = "John";
            dr["LastName"] = "Smith";
            dr["Date"] = "2/5/15";
            dr["Age"] = 29;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "Sue";
            dr["LastName"] = "Gaskins";
            dr["Date"] = "2/2/12";
            dr["Age"] = 32;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "John";
            dr["LastName"] = "Jacobs";
            dr["Date"] = "2/5/15";
            dr["Age"] = 56;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "Sam";
            dr["LastName"] = "Garfunkel";
            dr["Date"] = "4/4/10";
            dr["Age"] = 39;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "George";
            dr["LastName"] = "Shepherd";
            dr["Date"] = "8/1/15";
            dr["Age"] = 39;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "Sue";
            dr["LastName"] = "Gaskins";
            dr["Date"] = "4/4/10";
            dr["Age"] = 32;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "John";
            dr["LastName"] = "Jacobs";
            dr["Date"] = "3/4/15";
            dr["Age"] = 56;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "Sam";
            dr["LastName"] = "Garfunkel";
            dr["Date"] = "7/8/12";
            dr["Age"] = 39;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "George";
            dr["LastName"] = "Shepherd";
            dr["Date"] = "3/4/15";
            dr["Age"] = 39;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "Sue";
            dr["LastName"] = "Gaskins";
            dr["Date"] = "6/9/13";
            dr["Age"] = 32;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "John";
            dr["LastName"] = "Jacobs";
            dr["Date"] = "3/4/15";
            dr["Age"] = 56;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "Sam";
            dr["LastName"] = "Garfunkel";
            dr["Date"] = "5/12/14";
            dr["Age"] = 39;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "George";
            dr["LastName"] = "Shepherd";
            dr["Date"] = "2/2/10";
            dr["Age"] = 39;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "Mary";
            dr["LastName"] = "Tucker";
            dr["Date"] = "1/2/13";
            dr["Age"] = 42;
            table.Rows.Add(dr);

            dr = table.NewRow();
            dr["FirstName"] = "Becky";
            dr["LastName"] = "Dunsford";
            dr["Date"] = "6/2/10";
            dr["Age"] = 33;
            table.Rows.Add(dr);
      
            dr = table.NewRow();
            dr["FirstName"] = "George";
            dr["LastName"] = "Shepherd";
            dr["Date"] = "9/2/10";
            dr["Age"] = 38;
            table.Rows.Add(dr);

            return table;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.gridGroupingControl1.TableDescriptor.Columns.Add("trial");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.gridGroupingControl1.TableDescriptor.VisibleColumns.RemoveAt(2);
        }

    }

    public class DateComparer : IComparer
    {
        public DateComparer() { }

        public int Compare(object x, object y)
        {
            DateTime value1 = DateTime.Parse(x.ToString());
            DateTime value2 = DateTime.Parse(y.ToString());

            //string value1 = x.ToString();
            //string value2 = y.ToString();
            return DateTime.Compare(value1,value2);
        }
    }
}
